﻿// <auto-generated />
using System;
using CreonitCargo;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace CreonitCargo.Migrations
{
    [DbContext(typeof(CargoDb))]
    [Migration("20230607140613_Initial")]
    partial class Initial
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.0-preview.4.23259.3")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("CreonitCargo.Models.ArtefactTable", b =>
                {
                    b.Property<int>("ID")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("ID"));

                    b.Property<string>("ArtefactPath")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<int>("Build")
                        .HasColumnType("integer");

                    b.Property<string>("Environment")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("ProjectTitle")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTimeOffset>("PublicationTimestamp")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Version")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("ID");

                    b.HasIndex("ProjectTitle");

                    b.ToTable("Artefacts");
                });

            modelBuilder.Entity("CreonitCargo.Models.ProjectTable", b =>
                {
                    b.Property<string>("Title")
                        .HasColumnType("text");

                    b.Property<string>("Icon")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Title");

                    b.ToTable("Projects");
                });

            modelBuilder.Entity("CreonitCargo.Models.ArtefactTable", b =>
                {
                    b.HasOne("CreonitCargo.Models.ProjectTable", "Project")
                        .WithMany("Artefacts")
                        .HasForeignKey("ProjectTitle")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Project");
                });

            modelBuilder.Entity("CreonitCargo.Models.ProjectTable", b =>
                {
                    b.Navigation("Artefacts");
                });
#pragma warning restore 612, 618
        }
    }
}
